{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 65520,0,655360}
Program biconex_radu;

Const
  MaxMuchii=25000;
  MaxVarfuri=2500;

Type
  PNod=^Nod;
  Nod=record
    inf:word;
    next:PNod;
  end;

  PArb=^Arb;
  Arb=record
    inf:word;
    fiu,frate:PArb;
    nrfrunze:word;
  end;

Var
  g:array[1..MaxVarfuri] of PNod;
  vizitat:array[1..MaxVarfuri] of word;
  minret:array[1..MaxVarfuri] of word;
  frunze:array[1..MaxVarfuri] of word;
  nr_frunze:word;
  nrc:word;
  n:word;

  rad:PArb;

Procedure citire;
  var f:text;
    i,s,d,k:word;
    p:pnod;
  begin
    assign(f,'roads.in');
    reset(f);
    readln(f,n,k);
    for i:=1 to n do g[i]:=nil;
    for i:=1 to k do begin
      readln(f,s,d);
      new(p);
      p^.inf:=s;
      p^.next:=g[d];
      g[d]:=p;
      new(p);
      p^.inf:=d;
      p^.next:=g[s];
      g[s]:=p;
    end;
    close(f);
  end;

Procedure CautaDF(nc,parinte:word);
  var p:PNod;
    i:word;
  begin
    nrc:=nrc+1;
    vizitat[nc]:=nrc;
    minret[nc]:=nrc;
    p:=g[nc];
    while p<>nil do begin
      i:=p^.inf;
      if vizitat[i]=0 then begin
        CautaDF(i,nc);
        if minret[i]<minret[nc] then minret[nc]:=minret[i];
      end else if i<>parinte then begin
        if vizitat[i]<minret[nc] then minret[nc]:=vizitat[i];
      end;
      p:=p^.next;
    end;
  end;

Procedure GenRedus(nc:word; var r:PArb);
  var p:PNod;
    i:word;
    pa:PArb;
    ppa:^Parb;
  begin
    nrc:=nrc+1;
    p:=g[nc];
    if minret[nc]=vizitat[nc] then begin
      new(pa);
      pa^.inf:=nc;
      pa^.fiu:=nil;
      pa^.frate:=r;
      r:=pa;
      ppa:=@r^.fiu;
    end else ppa:= @r;
    while p<>nil do begin
      i:=p^.inf;
      if vizitat[i]=nrc+1 then begin
        GenRedus(i,ppa^);
      end;
      p:=p^.next;
    end;
  end;

Procedure Arbore;
  var i:word;
  begin
    for i:=1 to n do vizitat[i]:=0;
    nrc:=0;
    CautaDF(1,0);
    rad:=nil;
    nrc:=0;
    GenRedus(1,rad);
  end;

Procedure CautaRadacina;
  var p,q,tmp:PArb;
  begin
    if rad^.fiu^.frate<>nil then begin
      q:=rad;
      p:=rad^.fiu;
      rad^.fiu:=p^.frate;
      while p^.fiu<>nil do begin
        q^.frate:=p^.fiu^.frate;
        tmp:=p;
        p:=p^.fiu;
        tmp^.fiu:=q;
        q:=tmp;
      end;
      q^.frate:=nil;
      p^.frate:=nil;
      p^.fiu:=q;
      rad:=p;
    end;
  end;

Procedure numara(r:PArb);
  var p:PArb;
    k:word;
  begin
    p:=r^.fiu;
    if p=nil then begin
      nr_frunze:=nr_frunze+1;
      frunze[nr_frunze]:=r^.inf;
    end else begin
      k:=0;
      while p<>nil do begin
        numara(p);
        p:=p^.frate;
      end;
    end;
  end;

Procedure Special;
  var p:PNod;
    i:word;
    pw:^word;
  begin
    pw:=@rad^.inf;
    i:=rad^.fiu^.inf;
    p:=g[pw^];
    if p^.inf=i then begin
      if p^.next=nil then begin
        i:=rad^.inf;
        pw:=@rad^.fiu^.inf;
        p:=g[pw^];
      end;
      while (p<>nil)and(p^.inf=i) do p:=p^.next;
      if p=nil then
        runerror(222);
      pw^:=p^.inf;
      nr_frunze:=0;
      numara(rad);
    end;
  end;

Procedure scrie;
  var i,j,k:word;
    f:text;
  begin
    assign(f,'roads.out');
    rewrite(f);
    if nr_frunze>0 then begin
      k:=nr_frunze div 2;
      writeln(f,k+1);
      for i:=1 to k do begin
        writeln(f,frunze[i],' ',frunze[nr_frunze+1-i]);
      end;
      writeln(f,rad^.inf,' ',frunze[k+1]);
    end else writeln(f,0);
    close(f);
  end;

Begin
  citire;
  Arbore;
  if rad^.fiu<>nil then begin
    CautaRadacina;
    numara(rad);
    if (nr_frunze=1) and (rad^.fiu^.fiu=nil) then special;
  end else nr_frunze:=0;
  scrie;
End.
