{
name: Mugurel Andreica
country: Romania
email: mugurel_ionut@yahoo.com
}

{ Punctaj: 60p/100p }

Program BITMAP;

const filein='bitmap.in';
      fileout='bitmap.out';
      MAXN=10000;
      MAXM=1000;
      dl:array[1..8] of integer=
         (-1,0,+1,0,-1,-1,+1,+1);
      dc:array[1..8] of integer=
         (0,+1,0,-1,-1,+1,-1,+1);

type plist=^list;
     list=record
          ll,cc:integer;
          urm:plist;
          end;

var fin,fout:text;
    mm:array[1..MAXN,1..MAXM] of byte;
    cst,cfin,aux:plist;
    i,j,k,m,n,p,q,jj,ncp,nco,nel,po:longint;
    simb,simb2,simb3,ndi:byte;
    compact:boolean;

procedure marc(li,co:integer);
var lli,cco,di:integer;
begin
new(cst);
cst^.ll:=li;
cst^.cc:=co;
cst^.urm:=nil;
cfin:=cst;
mm[li,co]:=simb;

while (cst<>nil) do
  begin
    lli:=cst^.ll;
    cco:=cst^.cc;

    for di:=1 to ndi do
      if (lli+dl[di]>0) and (lli+dl[di]<=n) and
         (cco+dc[di]>0) and (cco+dc[di]<=m) and
         (mm[lli+dl[di],cco+dc[di]]=simb2)
      then
        begin
          mm[lli+dl[di],cco+dc[di]]:=simb;

          new(aux);
          aux^.ll:=lli+dl[di];
          aux^.cc:=cco+dc[di];
          aux^.urm:=nil;
          cfin^.urm:=aux;
          cfin:=aux;
        end;

    aux:=cst;
    cst:=cst^.urm;
    dispose(aux);
  end;
end;

procedure marc2(li,co:integer);
var lli,cco,di:integer;
begin
new(cst);
cst^.ll:=li;
cst^.cc:=co;
cst^.urm:=nil;
cfin:=cst;
mm[li,co]:=5;

while (cst<>nil) do
  begin
    lli:=cst^.ll;
    cco:=cst^.cc;

    if (mm[lli,cco]=3) then
    begin
    for di:=1 to 8 do
      if (lli+dl[di]>0) and (lli+dl[di]<=n) and
         (cco+dc[di]>0) and (cco+dc[di]<=m) and
         (mm[lli+dl[di],cco+dc[di]]=0)
      then
        begin
          mm[lli+dl[di],cco+dc[di]]:=3;

          new(aux);
          aux^.ll:=lli+dl[di];
          aux^.cc:=cco+dc[di];
          aux^.urm:=nil;
          cfin^.urm:=aux;
          cfin:=aux;
        end;
    end
    else
    begin
    for di:=1 to 4 do
      if (lli+dl[di]>0) and (lli+dl[di]<=n) and
         (cco+dc[di]>0) and (cco+dc[di]<=m) and
         (mm[lli+dl[di],cco+dc[di]]=1)
      then
        begin
          mm[lli+dl[di],cco+dc[di]]:=5;

          new(aux);
          aux^.ll:=lli+dl[di];
          aux^.cc:=cco+dc[di];
          aux^.urm:=nil;
          cfin^.urm:=aux;
          cfin:=aux;
        end;

    for di:=1 to 4 do
      if (lli+dl[di]>0) and (lli+dl[di]<=n) and
         (cco+dc[di]>0) and (cco+dc[di]<=m) and
         (mm[lli+dl[di],cco+dc[di]]=0)
      then
        begin
          mm[lli+dl[di],cco+dc[di]]:=3;
          compact:=false;

          new(aux);
          aux^.ll:=lli+dl[di];
          aux^.cc:=cco+dc[di];
          aux^.urm:=nil;
          cfin^.urm:=aux;
          cfin:=aux;
        end;

    end;

    aux:=cst;
    cst:=cst^.urm;
    dispose(aux);
  end;
end;


begin
assign(fin,filein);
reset(fin);
readln(fin,n,m);

for i:=1 to n do
  begin
    p:=0; j:=0;
    read(fin,q);

    while (q>-1) do
      begin
        for jj:=j+1 to j+q do
          mm[i,jj]:=p;

        j:=j+q;
        p:=1-p;
        read(fin,q);
      end;

    readln(fin);
  end;
close(fin);


for i:=1 to n do
  begin
    for j:=1 to m do
      write(mm[i,j],' ');
    writeln;
  end;

simb:=3;
simb2:=0;
ndi:=8;

for i:=1 to n do
  begin
    if (mm[i,1]=0) then
      marc(i,1);
    if (mm[i,m]=0) then
      marc(i,m);
  end;

for j:=1 to m do
  begin
    if (mm[1,j]=0) then
      marc(1,j);
    if (mm[n,j]=0) then
      marc(n,j);
  end;

ncp:=0;
nco:=0;

simb:=5;
simb2:=1;
simb3:=0;
ndi:=4;

for i:=1 to n do
  for j:=1 to m do
    if (mm[i,j]=1) then
      begin
        inc(ncp);
        compact:=true;

        marc2(i,j);

        if (compact) then
          inc(nco);
      end;

assign(fout,fileout);
rewrite(fout);
writeln(fout,ncp);
writeln(fout,nco);
close(fout);
end.