{
name: Mugurel Andreica
country: Romania
email: mugurel_ionut@yahoo.com
}

{ Punctaj: 100p/100 }

{$I-,R-,Q-}
{$M 65000,0,655360}

Program CIRCUIT;

const filein='circuit.in';
      fileout='circuit.out';
      MAXN=101;

type lcarray=array[1..MAXN*MAXN] of byte;
     matarray=array[1..MAXN,1..MAXN] of byte;
     nivarray=array[1..MAXN*MAXN] of integer;

var fin,fout:text;
    board:array[1..MAXN,1..MAXN] of byte;
    con:array[1..MAXN,1..MAXN] of integer;
    i,j,k,m,n,p,q,nco,po,nel,cost,nseg,ti,tj:integer;
    tata:array[1..MAXN*MAXN] of integer;
    clin,ccol:^lcarray;
    sseg:^matarray;
    niv:^nivarray;

begin
assign(fin,filein);
reset(fin);
readln(fin,n,m);

fillchar(board,sizeof(board),0);

for i:=1 to n do
  begin
    for j:=1 to m do
      read(fin,board[i,j]);
    readln(fin);
  end;
close(fin);

fillchar(con,sizeof(con),0);
nco:=0;

new(clin);
fillchar(clin^,sizeof(clin^),0);
new(ccol);
fillchar(ccol^,sizeof(ccol^),0);

for i:=1 to n do
  for j:=1 to m do
  if (con[i,j]=0) then
    begin
      inc(nco);
      con[i,j]:=nco;

      po:=1;
      nel:=1;

      clin^[1]:=i;
      ccol^[1]:=j;

      while (po<=nel) do
        begin
          p:=clin^[po];
          q:=ccol^[po];

          if (p+1<=n) and (con[p+1,q]=0) and
             ((board[p,q]=1) or (board[p,q]=3)) then
            begin
              con[p+1,q]:=nco;
              inc(nel);
              clin^[nel]:=p+1;
              ccol^[nel]:=q;
            end;

          if (q+1<=m) and (con[p,q+1]=0) and
             ((board[p,q]=2) or (board[p,q]=3)) then
            begin
              con[p,q+1]:=nco;
              inc(nel);
              clin^[nel]:=p;
              ccol^[nel]:=q+1;
            end;

          if (p-1>0) and (con[p-1,q]=0) and
             ((board[p-1,q]=1) or (board[p-1,q]=3)) then
            begin
              con[p-1,q]:=nco;
              inc(nel);
              clin^[nel]:=p-1;
              ccol^[nel]:=q;
            end;

          if (q-1>0) and (con[p,q-1]=0) and
             ((board[p,q-1]=2) or (board[p,q-1]=3)) then
            begin
              con[p,q-1]:=nco;
              inc(nel);
              clin^[nel]:=p;
              ccol^[nel]:=q-1;
            end;

          inc(po);
        end;
    end;

fillchar(tata,sizeof(tata),0);
dispose(clin);
dispose(ccol);
new(sseg);
fillchar(sseg^,sizeof(sseg^),0);
new(niv);
fillchar(niv^,sizeof(niv^),0);

for i:=1 to nco do
  niv^[i]:=1;

nseg:=0;
cost:=0;

for i:=2 to n do
  for j:=1 to m do
    begin
      ti:=con[i-1,j];
      tj:=con[i,j];

      while (tata[ti]>0) do
        ti:=tata[ti];

      while (tata[tj]>0) do
        tj:=tata[tj];

      if (ti<>tj) then
        begin
          inc(nseg);
          cost:=cost+1;
          sseg^[i-1,j]:=sseg^[i-1,j]+1;

          if (niv^[ti]>niv^[tj]) then
            tata[tj]:=ti
          else
          if (niv^[tj]>niv^[ti]) then
            tata[ti]:=tj
          else
            begin
              tata[tj]:=ti;
              inc(niv^[ti]);
            end;
        end;
    end;


for i:=1 to n do
  for j:=2 to m do
    begin
      ti:=con[i,j-1];
      tj:=con[i,j];

      while (tata[ti]>0) do
        ti:=tata[ti];

      while (tata[tj]>0) do
        tj:=tata[tj];

      if (ti<>tj) then
        begin
          inc(nseg);
          cost:=cost+2;
          sseg^[i,j-1]:=sseg^[i,j-1]+2;

          if (niv^[ti]>niv^[tj]) then
            tata[tj]:=ti
          else
          if (niv^[tj]>niv^[ti]) then
            tata[ti]:=tj
          else
            begin
              tata[tj]:=ti;
              inc(niv^[ti]);
            end;
        end;
    end;

assign(fout,fileout);
rewrite(fout);
writeln(fout,nseg,' ',cost);

for i:=1 to n do
  for j:=1 to m do
    begin
      if (sseg^[i,j]=1) then
        writeln(fout,i,' ',j,' ',1)
      else
      if (sseg^[i,j]=2) then
        writeln(fout,i,' ',j,' ',2)
      else
      if (sseg^[i,j]=3) then
        begin
          writeln(fout,i,' ',j,' ',1);
          writeln(fout,i,' ',j,' ',2);
        end;
    end;

close(fout);
end.