/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

#include <stdio.h>
#include <string.h>

int bit[11]={0,1,2,4,8,16,32,64,128,256,512};
unsigned char max[1024][1024],act[1024][1024];
int i,j,p,ii,jj,k,m,n,nt,bs,i1,i2,maxv,nch,nok,str,prev;
int board[152][12],bnew[152][12],row[1024][12],stack[12];

void buildrow(int niv)
{
if (niv==m+1)
  {
  for (i=1;i<=m;i++)
    row[maxv][i]=stack[i];
  }
else
  {
  stack[niv]=0;
  buildrow(niv+1);

  stack[niv]=1;
  maxv+=bit[niv];
  buildrow(niv+1);
  maxv-=bit[niv];
  }
}

void back(int r,int c)
{
if (r==str+2)
  {
  for (jj=1,i1=0;jj<=m;jj++)
    if (bnew[str+1][jj]==1)
      i1+=bit[jj];

  for (jj=1,i2=0;jj<=m;jj++)
    if (bnew[str+2][jj]==1)
      i2+=bit[jj];

  if ((nch+prev>max[i1][i2]) || (max[i1][i2]==255))
    {
    max[i1][i2]=nch+prev;
    if (nch+prev>nok)
      nok=nch+prev;
    }
  }
else
if (r==0)
  back(r+1,1);
else
  {
  if ((bnew[r][c]==0) && (bnew[r][c+1]==0) && (bnew[r][c+2]==0) &&
     (bnew[r+1][c]==0) && (bnew[r+1][c+1]==0) && (bnew[r+1][c+2]==0) &&
     (c+2<=m))
     {
     bnew[r][c]=bnew[r][c+1]=bnew[r][c+2]=1;
     bnew[r+1][c]=bnew[r+1][c+1]=bnew[r+1][c+2]=1;
     nch++;

     if (c+3<=m-1)
       back(r,c+3);
     else
       back(r+1,1);

     bnew[r][c]=bnew[r][c+1]=bnew[r][c+2]=0;
     bnew[r+1][c]=bnew[r+1][c+1]=bnew[r+1][c+2]=0;
     nch--;
     }

  if ((bnew[r][c]==0) && (bnew[r+1][c]==0) && (bnew[r+2][c]==0) &&
     (bnew[r][c+1]==0) && (bnew[r+1][c+1]==0) && (bnew[r+2][c+1]==0) &&
     (r==str))
     {
     bnew[r][c]=bnew[r+1][c]=bnew[r+2][c]=1;
     bnew[r+1][c]=bnew[r+1][c+1]=bnew[r+2][c+1]=1;
     nch++;

     if (c+2<=m-1)
       back(r,c+2);
     else
       back(r+1,1);

     bnew[r][c]=bnew[r+1][c]=bnew[r+2][c]=0;
     bnew[r+1][c]=bnew[r+1][c+1]=bnew[r+2][c+1]=0;
     nch--;
     }

  if (c<m-1)
    back(r,c+1);
  else
    back(r+1,1);
  }
}

void main()
{
freopen("bugs.in","r",stdin);
freopen("bugs.out","w",stdout);
scanf("%d",&nt);

while (nt)
  {
  scanf("%d %d %d",&n,&m,&bs);
  memset(board,0,sizeof(board));

  for (k=1;k<=bs;k++)
    {
    scanf("%d %d",&i,&j);
    board[i][j]=1;
    }

  if (m==1)
    printf("0\n");
  else
  if (m==2)
    {
    nok=0;
    for (i=1;i<=n-2;i++)
      if (
         (board[i][1]==0) && (board[i][2]==0) &&
         (board[i+1][1]==0) && (board[i+1][2]==0) &&
         (board[i+2][1]==0) && (board[i+2][2]==0)
         )
        {
        board[i][1]=board[i][2]=1;
        board[i+1][1]=board[i+1][2]=1;
        board[i+2][1]=board[i+2][2]=1;
        nok++;
        }

    printf("%d\n",nok);
    }
  else
    {
    maxv=0;
    buildrow(1);
    maxv=(bit[m]<<1);

    for (i=0;i<maxv;i++)
      for (j=0;j<maxv;j++)
        max[i][j]=255;

    for (i=1;i<=2;i++)
      for (j=1;j<=m;j++)
        bnew[i][j]=board[i][j];

    nch=nok=str=prev=0;
    back(0,1);

    for (i=0;i<maxv;i++)
      for (j=0;j<maxv;j++)
        act[i][j]=max[i][j];

    for (k=3;k<=n;k++)
      {
      for (i=0;i<maxv;i++)
        for (j=0;j<maxv;j++)
          max[i][j]=255;

      for (i=0;i<maxv;i++)
        for (j=0;j<maxv;j++)
          if (act[i][j]<255)
            {
            for (p=1;p<=m;p++)
              {
              bnew[k-2][p]=row[i][p];
              bnew[k-1][p]=row[j][p];
              }

            for (p=1;p<=m;p++)
              bnew[k][p]=board[k][p];

            prev=act[i][j];
            nch=0; str=k-2;

            back(k-2,1);
            }

      for (i=0;i<maxv;i++)
        for (j=0;j<maxv;j++)
          act[i][j]=max[i][j];
      }

    printf("%d\n",nok);
    }

  nt--;
  }
}
