/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

/* Time Complexity: O(N) */

/* Score: 100 points */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "square_lib.h"
#define maxn 2004

int edge[maxn];
int N,L,x,y,dact,w,lastw;

int main()
{
N=getN();
L=getL();

/* move to the right */
x=y=1; dact=0;
while (x<N)
  {
  w=getWeight(x,y,0);
  if (L-w>=dact)
    {
    edge[x]=w;
    dact+=w;
    x++;
    }
  else
    break;
  }

/* move down */
while (y<N)
  {
  w=getWeight(x,y,1);
  if (L-w>=dact)
    {
    lastw=w;
    dact+=w;
    y++;
    }
  else
    break;
  }

if (dact==L)
  solution(x,y);

while (x>1)
  {
  x--;
  if (y==1)
    dact-=edge[x];
  else
    {
    /* y--; */
    w=getWeight(x,y,0);
    dact=dact-w/*-lastw*/;
    }

  while (y<N)
    {
    w=getWeight(x,y,1);
    if (L-w>=dact)
      {
      lastw=w;
      dact+=w;
      y++;
      }
    else
      break;
    }

  if (dact==L)
    solution(x,y);
  }

solution(-1,-1);
return 0;
}
