/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

/* Score: 100 points */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define filein "trip.in"
#define fileout "trip.out"
#define maxn 101
#define maxtip 1000

typedef struct nod { char ch; nod* next[26]; } NOD;

NOD *root,*aux;
char a[maxn],b[maxn],stack[maxn];
long max[maxn][maxn],tip[maxn][maxn];
long used[maxn][26];
long i,j,k,lit,n1,n2,ntip;

void bkt(long i,long j,long niv,long ok,NOD* pnod)
{
long ii,jj;

if (niv==0)
  {
  if (ok)
    {
    for (i=1;i<=max[n1][n2];i++)
      printf("%c",stack[i]);
    printf("\n");

    ntip++;
    if (ntip==maxtip)
      {
      exit(0);
      }
    }
  }
else
  {
  if (a[i-1]==b[j-1])
    {
    lit=a[i-1];
    stack[niv]=lit;

    if (pnod->next[lit-'a']==NULL)
      {
      aux=new NOD;
      for (k=0;k<26;k++)
        aux->next[k]=NULL;
      pnod->next[lit-'a']=aux;

      bkt(i-1,j-1,niv-1,1,aux);
      }
    else
      bkt(i-1,j-1,niv-1,0,pnod->next[lit-'a']);

    for (ii=i-1;ii>=1;ii--)
      for (jj=j-1;jj>=1;jj--)
        if (max[ii][jj]==niv && tip[ii][jj]==2 && a[ii-1]!=a[i-1])
          bkt(ii,jj,niv,ok,pnod);
    }
  else
    {
    for (ii=i;ii>=1;ii--)
      for (jj=j;jj>=1;jj--)
        if (max[ii][jj]==niv && tip[ii][jj]==2)
          bkt(ii,jj,niv,ok,pnod);
    }
  }
}

int main()
{
freopen(filein,"r",stdin);
scanf("%s",&a);
scanf("%s",&b);
n1=strlen(a);
n2=strlen(b);

memset(max,0,sizeof(max));
memset(tip,0,sizeof(tip));
for (i=1;i<=n1;i++)
  for (j=1;j<=n2;j++)
    if (a[i-1]==b[j-1])
      {
      max[i][j]=max[i-1][j-1]+1;
      tip[i][j]=2;
      }
    else
      {
      max[i][j]=0;
      if (max[i-1][j]>max[i][j])
        max[i][j]=max[i-1][j];
      if (max[i][j-1]>max[i][j])
        max[i][j]=max[i][j-1];
      tip[i][j]=1;
      }

freopen(fileout,"w",stdout);

root=new NOD;
for (i=0;i<26;i++)
  root->next[i]=NULL;

ntip=0;
bkt(n1,n2,max[n1][n2],0,root);

return 0;
}
