#include <stdio.h>
#include <string.h>
#include <algorithm>

using namespace std;

#define MAX_N 1005
#define MAX_M 20005
#define FIN "logs.in"
#define FOUT "logs.out"

int N, M, H[MAX_M], T[MAX_M], cnt[MAX_M], res;
char A[MAX_M];

int main(void) {
  int i, j;

  freopen(FIN, "r", stdin);
  freopen(FOUT, "w", stdout);

  scanf("%d %d\n", &N, &M);
  for (i = 0; i < N; ++i) {
    fgets(A, M+2, stdin);
    for (j = 0; j < M; ++j)
      H[j] = A[j] == '1' ? H[j]+1 : 0;

    memset(cnt, 0, (i+2)*sizeof(int));
    for (j = 0; j < M; ++j)
      ++cnt[H[j]];
    for (j = 1; j <= i+1; ++j)
      cnt[j] += cnt[j-1];
    for (j = M-1; j >= 0; --j)
      T[--cnt[H[j]]] = H[j];

    for (j = 0; j < M; ++j)
      res = max(res, T[j]*(M-j));
  }

  printf("%d\n", res);

  return 0;
}
