/*
Author:        Adrian Diaconu
Description:   ???
*/
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

#define nmax 256
#define cmax 100000
#define f first
#define s second
#define mp make_pair
#define si short int
#define FOR(i, s, d) for(i = (s); i < (d); ++i)

int n, sol, A;
pair<int, int> P[nmax];
int bal[nmax];
map<vector<si>, int> H;

void place(int a, int b, int st, int z)
{
  int i;
  FOR(i, st, n)
    if(a <= P[i].s && P[i].s <= b)
      bal[i] += z;
}

vector<si> encode()
{
  vector<si> x;
  x.clear();
  si i;
  FOR(i, 0, n)
    if(bal[i])
      x.push_back(i);
  return x;
}

void doit(int i, int x)
{
  if(x >= sol) return;
  if(i == n)
  {
    sol = x;
    return ;
  }
  if(bal[i])
  {
    doit(i + 1, x);
    return ;
  }
  vector<si> poz = encode();
  if(H.size() > cmax) return;
  if(poz.size())
  {
    if(H[poz] <= x && H[poz] > 0) return;
    H[poz] = x;
  }
  int L = A / P[i].f, j, count = 10;
  FOR(j, i, n)
  {
    if(count == 0) break;
    if(P[i].s > P[j].s && P[i].s - P[j].s <= L)
    {
      place(P[j].s, P[j].s + L, i, 1);
      doit(i + 1, x + 1);
      place(P[j].s, P[j].s + L, i, -1);
      --count;
    }
  }
  if(count)
  {
    place(P[i].s, P[i].s + L, i, 1);
    doit(i + 1, x + 1);
    place(P[i].s, P[i].s + L, i, -1);
  }
}

int main()
{
  freopen("photo.in", "r", stdin);
  freopen("photo.out", "w", stdout);
  int i;
  scanf("%d %d", &n, &A);
  FOR(i, 0, n)
    scanf("%d %d",&P[i].s, &P[i].f);
  sort(P, P + n);
  reverse(P, P + n);
  sol = n;
  doit(0, 0);
  printf("%d\n", sol);
  return 0;
}
