/*
Finished N = 1 at Tue Jun 16 10:55:41 2009
Finished N = 2 at Tue Jun 16 10:55:41 2009
Finished N = 3 at Tue Jun 16 10:55:41 2009
Finished N = 4 at Tue Jun 16 10:55:41 2009
Finished N = 5 at Tue Jun 16 10:55:41 2009
Finished N = 6 at Tue Jun 16 10:55:41 2009
Finished N = 7 at Tue Jun 16 10:55:41 2009
Finished N = 8 at Tue Jun 16 10:55:41 2009
Finished N = 9 at Tue Jun 16 10:55:41 2009
Finished N = 10 at Tue Jun 16 10:55:43 2009
Finished N = 11 at Tue Jun 16 10:55:58 2009
Finished N = 12 at Tue Jun 16 10:59:40 2009
Finished N = 13 at Tue Jun 16 11:53:49 2009
*/

#include <stdio.h>
#include <time.h>
#include <algorithm>

#define NMAX 25
#define cmax(x) ((x) * ((x) + 1) / 2)
#define MOD 30011

using namespace std;

int A[NMAX][cmax(NMAX)][cmax(NMAX)];
int P[NMAX + 1], P2[NMAX + 1], N;

int count_bubble() {
  int i, j, result = 0;

  for (i = 1; i < N; i++) {
    for (j = 0; j < i; j++) {
      if (P[i] < P[j]) {
        result++;
      }
    }
  }

  return result;
}

int count_quick(int l, int r) {
  int less[r-l], greater[r-l];
  int i, nl = 0, ng = 0;

  if (r - l < 2) {
    return 0;
  }

  for (i = l+1; i < r; i++) {
    if (P2[i] > P2[l]) {
      greater[ng++] = P2[i];
    } else {
      less[nl++] = P2[i];
    }
  }

  for (i = l+1; i <= l+nl; i++) {
    P2[i] = less[i - l - 1];
  }

  for (i = l + nl + 1; i < r; i++) {
    P2[i] = greater[i - l - nl - 1];
  }

  return (r-l-1) + count_quick(l+1, l + nl + 1) + count_quick(l + nl + 1, r);
}

int main() {
  int i, j, b, q, s;
  time_t curtime;
  struct tm *loctime;

  for (N = 1; N < NMAX; N++) {
    for (i = 0; i < N; i++) {
      P[i] = i;
    }

    do {
      b = count_bubble();
      for (i = 0; i < N; i++) {
        P2[i] = P[i];
      }
      q = count_quick(0, N);

      // no modulo here to make it faster
      A[N][q][b]++;
    } while (next_permutation(P, P + N));

    s = 0;
    for (i = 0; i <= cmax(N); i++) {
      for (j = 0; j <= cmax(N); j++) {
        printf("%6d", A[N][i][j] % MOD);
        s = (s + A[N][i][j]) % MOD;
      }
      printf("\n");
    }
    curtime = time(NULL);
    loctime = localtime (&curtime);
    fprintf(stderr, "Finished N = %d at ", N);
    fputs(asctime(loctime), stderr);
  }

  return 0;
}
