#include <stdio.h>
#include <assert.h>

#define NMAX 32
#define cmax(x) ((x) * ((x) + 1) / 2)
#define MOD 30011

int A[NMAX][cmax(NMAX)][cmax(NMAX)];

int N, X;

int main() {
  int n, i, j, result = 0;

  scanf("%d %d", &N, &X);
  freopen("matrix.txt", "r", stdin);

  for (n = 1; n < NMAX; n++) {
    for (i = 0; i <= cmax(n); i++) {
      for (j = 0; j <= cmax(n); j++) {
        scanf("%d", &A[n][i][j]);
      }
    }
  }

  for (i = 0; i <= cmax(N); i++) {
    for (j = 0; j <= cmax(N); j++) {
      if (i * X  >= j + (N - 1)) {
        printf("%d %d %d\n", i, j, A[N][i][j]);
        result = (result + A[N][i][j]) % MOD;
      }
    }
  }

  printf("%d\n", result);

  return 0;
}
