{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R+,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}
type capat = record
               h,x:integer;
               cost:longint;
               os,s:integer;    { original segment, segment }
               c:byte;
               ts:integer;   { tata - segment }
               tc:byte;      { tata - capat }
             end;
     segm = record
              c1,c2:capat;
            end;
const max=1003;
var nrmax,min,cursor,hh,nr1,nr2,p,i,j,k,l,m,n,x1,x2,h,x,y,hmax:longint;
    a:array[1..max]of segm;
    f,fn:array[1..max]of capat;
    fi,fo:text;
    st:capat;
    tl1:longint;
    tl2:longint absolute $0:$46c;


procedure readdata;
begin
  assign(fi,'fall.in');
  assign(fo,'fall.out');
  reset(fi);
  readln(fi,n,x,y,hmax);
  for i:=1 to n do
      begin
        readln(fi,x1,x2,h);
        a[i].c1.h:=h;
        a[i].c1.x:=x1;
        a[i].c1.cost:=1000000;
        a[i].c1.os:=i;
        a[i].c1.c:=1;
        a[i].c2.x:=x2;
        a[i].c2.h:=h;
        a[i].c2.cost:=1000000;
        a[i].c2.os:=i;
        a[i].c2.c:=2;
      end;
  close(fi);
  h:=y;
end;

procedure Sort(l, r: Integer);
var
  i, j, x : longint;
  y:segm;
begin
  i := l; j := r; x := (h-a[(l+r) DIV 2].c1.h)*100000+a[(l+r)div 2].c1.x;
  repeat
    while (h-a[i].c1.h)*100000+a[i].c1.x < x do i := i + 1;
    while x < (h-a[j].c1.h)*100000+a[j].c1.x do j := j - 1;
    if i <= j then
    begin
      y := a[i]; a[i] := a[j]; a[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

procedure init;
begin
  nr1:=1;
  f[1].x:=x;
  f[1].h:=h;
  f[1].cost:=0;
  st:=f[1];
end;

procedure rec(var c:capat);
var xx:longint;
begin
  if c.s=0 then
     begin
       exit;
     end;
  if c.ts=0 then
     rec(st);
  if c.ts<>0 then
     begin
       if c.tc=1 then
          rec(a[c.ts].c1)
          else
          rec(a[c.ts].c2);
     end;
  if c.ts=0 then
     write(fo,c.os,' ',c.cost-abs(x-c.x),' ',c.c-1)
     else
     begin
       xx:=c.cost;
       if c.tc=1 then
          xx:=xx-abs(c.x-a[c.ts].c1.x)
          else
          xx:=xx-abs(c.x-a[c.ts].c2.x);
       write(fo,c.os,' ',xx,' ',c.c-1);
     end;
  writeln(fo);
end;

procedure solve;
begin
  sort(1,n);
  for i:=1 to n do
      begin
        a[i].c1.s:=i;
        a[i].c2.s:=i;
      end;
  init;
  cursor:=1;

  for hh:=h downto 1 do
      if a[cursor].c1.h=hh then
      begin
           { keep only the good ones }
        if nr1>nrmax then nrmax:=nr1;
        nr2:=0;
        fillchar(fn,sizeof(fn),0);
        for i:=1 to nr1 do
            if f[i].h-hh<=hmax then
               begin
                 inc(nr2);
                 fn[nr2]:=f[i];
               end;
        nr1:=nr2;
        f:=fn;
        nr2:=0;
        fillchar(fn,sizeof(fn),0);

          { compute the optimal cost for current segments }
        p:=1;
        while (a[cursor].c1.h=hh)and(p<=nr1) do
          begin
            { daca e inainte de segment, il pastrez }
            while (f[p].x<a[cursor].c1.x)and(p<=nr1) do
              begin
                inc(nr2);
                fn[nr2]:=f[p];
                inc(p);
              end;
            { am ajuns pe segment }

            { calculez optimul pt. fiecare capat }
            while (f[p].x<=a[cursor].c2.x)and(p<=nr1) do
              begin
                if f[p].cost+f[p].h-hh+f[p].x-a[cursor].c1.x<a[cursor].c1.cost then
                   begin
                     a[cursor].c1.cost:=f[p].cost+f[p].h-hh+f[p].x-a[cursor].c1.x;
                     a[cursor].c1.ts:=f[p].s;
                     a[cursor].c1.tc:=f[p].c;
                   end;
                if f[p].cost+f[p].h-hh+a[cursor].c2.x-f[p].x<a[cursor].c2.cost then
                   begin
                     a[cursor].c2.cost:=f[p].cost+f[p].h-hh+a[cursor].c2.x-f[p].x;
                     a[cursor].c2.ts:=f[p].s;
                     a[cursor].c2.tc:=f[p].c;
                   end;
                inc(p);
              end;
            { bag capetele }
            if a[cursor].c1.cost<1000000 then
               begin
                 inc(nr2);
                 fn[nr2]:=a[cursor].c1;
                 inc(nr2);
                 fn[nr2]:=a[cursor].c2;
               end;
            inc(cursor);
          end;
        while p<=nr1 do
          begin
            inc(nr2);
            fn[nr2]:=f[p];
            inc(p);
          end;
        while (a[cursor].c1.h=hh) do
          inc(cursor);

        nr1:=nr2;
        f:=fn;
      end;
  min:=100000000;
  for i:=1 to nr1 do
      begin
        if f[i].h<=hmax then
           if f[i].cost+f[i].h<min then
              min:=f[i].cost+f[i].h;
      end;
  rewrite(fo);
  writeln(fo,min);
  for i:=1 to nr1 do
      begin
        if f[i].h<=hmax then
           if f[i].cost+f[i].h=min then
              begin
                rec(f[i]);
                close(fo);
                halt;
              end;
      end;
  close(fo);
end;

begin
  readdata;
  solve;
end.