program pom;
const nmax=1000;
      inFileName='x.in';
      outFileName='x.out';

type {matrix=array[1..nmax, 1..nmax] of integer;}
     vector=array[1..nmax] of integer;
     pair=array[0..1] of integer;
     tri=array[0..2] of integer;
     rez=array[0..3, 0..3] of integer;
     prez2=^rez2;
     prez3=^rez3;
     plistar3=^listar3;
     listar3=record
       v:prez3;
       int:rez;
       next:plistar3;
     end;
     rez2=record
       r:rez;
       p:pair;
       n:integer;
       c:plistar3;
       {int:array[1..nmax] of rez;}
     end;
     rez3=record
       r:rez;
       t:tri;
       c:array[1..2] of prez2;
     end;
     plista=^lista;
     lista=record
       v:integer;
       next:plista;
     end;


const rez2simple:rez=((0, -1, -1, -1), (0, -1, -1, -1), (0, -1, -1, -1), (0, -1, -1, -1));
var  a:array[1..nmax] of plista;
     arity, state, used:vector;
     n:integer;


procedure init;
var i, j, x, y:integer; f:text;p:plista;
begin
  assign(f, inFileName);reset(f);
  read(f, n);
  for i:=1 to n do begin
    arity[i]:=0;
    for j:=1 to n do a[i]:=nil;
  end;
  for i:=1 to n*2-3 do begin
    read(f, x, y);
    new(p);p^.v:=y;p^.next:=a[x];a[x]:=p;
    new(p);p^.v:=x;p^.next:=a[y];a[y]:=p;
    inc(arity[x]); inc(arity[y]);
  end;
  for i:=1 to n do read(f, state[i]);
  close(f);
end;

function av(x, y:integer):boolean;
var p:plista;
begin
  p:=a[x];av:=false;
  while p<>nil do begin
    if p^.v=y then begin
      av:=true;
      break;
    end;
    p:=p^.next;
  end;
end;

procedure combine2(var a, b, c:rez);
var i, j, k:integer;r:rez;
begin
  for i:=0 to 3 do for j:=0 to 3 do r[i, j]:=-1;
  for i:=0 to 3 do
    for j:=0 to 3 do if a[i,j]>=0 then
      for k:=0 to 3 do if b[i, k]>=0 then
        r[i, j xor k]:=i*64+j*16+i*4+k;
  c:=r;
end;
procedure combine3(var a, b, c:rez; st:integer);
var i, j, k, l:integer;r:rez;
begin
  for i:=0 to 3 do for j:=0 to 3 do r[i, j]:=-1;
  for i:=0 to 3 do
    for j:=0 to 3 do if (i div 2)=(j div 2) then
      for k:=0 to 3 do if a[i, k]>=0 then
        for l:=0 to 3 do if b[j, l]>=0 then
          if (st xor (i div 2) xor (i mod 2) xor (j mod 2)
                 xor (k div 2) xor (l div 2))=1 then

            r[ (i mod 2) * 2 + (j mod 2),
               ( (i div 2) xor (k mod 2)) * 2+
                 ((i div 2) xor (l mod 2) ) ] :=
                   i*64+k*16+j*4+l;
  c:=r;
end;


procedure writesol2(r:prez2; x, y:integer; var f:text);forward;
procedure writesol3(r:prez3; x, y:integer; var f:text);
var i, t:integer;
begin
  t:=r^.r[x, y];
  writesol2(r^.c[1], (t div 64) mod 4, (t div 16) mod 4, f);
  writesol2(r^.c[2], (t div 4) mod 4, t  mod 4, f);
  if ((t div 4) mod 4) div 2=1 then write(f, r^.t[2], ' ');
end;

procedure writesol2(r:prez2; x, y:integer; var f:text);
var t,i:integer;p:plistar3;
begin
  if r^.n>0 then begin
    p:=r^.c;
    while p<>nil do begin
      t:=p^.int[x, y];
      writesol3(p^.v, (t div 4) mod 4, t mod 4, f);
      x:=(t div 64) mod 4;
      y:=(t div 16) mod 4;

      p:=p^.next;
    end;
  end;
end;

function solve3(t:tri):prez3;forward;
function solve2(p:pair):prez2;
var r:prez2;
    t:tri;
    i, k:integer;
    lp:plistar3;
begin
  new(r); t[0]:=p[0];t[1]:=p[1]; used[p[0]]:=1; used[p[1]]:=1; k:=0;
  r^.c:=nil;
  r^.r:=rez2simple;

  for i:=1 to n do if (used[i]=0)and av(p[0], i)and av(p[1], i) then begin
    t[2]:=i;inc(k);
    new(lp);lp^.next:=r^.c;
    lp^.v:=solve3(t);
    r^.c:=lp;
    combine2(r^.r, lp^.v^.r , r^.r );
    lp^.int:=r^.r;
  end;
  r^.n:=k;r^.p:=p;
  solve2:=r;
end;

function solve3(t:tri):prez3;
var r:prez3;p:pair;
begin
  new(r);r^.t:=t;
  p[0]:=t[2];
  p[1]:=t[0]; r^.c[1]:=solve2(p);
  p[1]:=t[1]; r^.c[2]:=solve2(p);
  combine3(r^.c[1]^.r, r^.c[2]^.r, r^.r, state[t[2]]);
  solve3:=r;
end;

procedure solve;
var first:pair;
    i, j, k:integer;
    ar:vector;
    r:rez2;
    rr:rez;
    sol:boolean;
    f:text;
begin
  k:=n;i:=1;ar:=arity;
  while k>2 do begin
    if ar[i]=2 then begin
      ar[i]:=0;
      for j:=1 to n do if av(i,j) then if ar[j]>0 then dec(ar[j]);
      dec(k);
    end;
    i:=i mod n +1;
  end;
  k:=0;
  for i:=1 to n do if ar[i]>0 then begin
    first[k]:=i;inc(k);
  end;
  for i:=1 to n do used[i]:=0;
  r:=solve2(first)^; rr:=r.r;
  assign(f, outFileName);rewrite(f);
  for i:=0 to 3 do
    for j:=0 to 3 do if rr[i, j]>=0 then
      if ((state[first[0]] xor (i div 2) xor (j div 2) xor (i mod 2))=1) and
         ((state[first[1]] xor (i mod 2) xor (j mod 2) xor (i div 2))=1)
         then begin
           if i div 2=1 then write(f, first[0], ' ');
           if i mod 2=1 then write(f, first[1], ' ');
           writesol2(addr(r), i, j, f);
           writeln(f);
           close(f);
           exit;
         end;

  writeln(f, 0);
  close(f);

end;



var time:longint absolute 0:$46C;
    t2:longint;

begin
  t2:=time;
  init;
  solve;
  writeln((time-t2)*1000/55:8:2);
end.                                                                          for k:=0 to 3 do if b[i, k]=1 then
